package ch.ethz.inf.dbproject.model;

import java.util.List;

/**
 * This class should be the interface between the web application
 * and the database. Keeping all the data-access methods here
 * will be very helpful for part 2 of the project.
 */
public interface DatastoreInterface {

	public abstract Project getProjectById(final int id);

	public abstract List<Project> getAllProjects();
	
	public abstract List<Project> getProjectByName(final String name);

	public abstract List<Project> getProjectsByCategory(final Category category);

	public abstract List<Project> getProjectsByCity(final String city);

	public abstract List<Project> getMostFundedProjects();
	
	public abstract List<Project> getSoonEndingProjects();
	
	public abstract List<Project> getMostPopularProjects();
	
	public abstract List<Amount> getAmountsOfProject(final int projectId);
	
	public abstract List<Comment> getProjectComments(final int projectId);

	public abstract List<Category> getAllCategories();
	
	public abstract User getUser(final String username, final String password);
	
	public abstract List<Project> getProjectsByOwner(final int userId);
}